#ifndef __HAPLOTYPE_LOADER_H__
#define __HAPLOTYPE_LOADER_H__

#include "Pedigree.h"
#include "Random.h"
#include "InputFile.h"

#include <stdio.h>

class ShotGun
   {
   public:
      ShotGun();
      ~ShotGun();

      void LoadMarkerPos(const char * filename);
      void LoadMarkerPos(IFILE file);

      void LoadHaplotypes(const char * filename, int numIndiv);
      void LoadHaplotypes(IFILE file, int numIndiv);
      
      void ShotGunRead(double start, double end, int reads, double erate, double complete, Random * rand = NULL);
      void PassHit(int nwts);

      int     bp;
      int     markerCount;
      int     readlength;
      int     count;
      // size: count X markerCount
      char ** haplotypes;
      
      // size: count X numberBasePairs
      char  ** sequencesOne;
      char  ** sequencesTwo;
      
      char  ** alleleOneCounts;
      char  ** alleleTwoCounts;
      char   * isPassHit;
      int     passHitMarkerCount;

   private:
      double square(double x)
         { return x * x; }

   };

#endif
